/*
 * Template function example
 * by hackervalley@free.fr
 * http://hackervalley.free.fr
 * January 2004
 * this program is licensed under the GPL.
 */

#include <iostream>

using namespace std;

void
SwapInt (int &ia, int &ib)
{
	int ic;
	ic = ia;
	ia = ib;
	ib = ic;
}

void
SwapFloat (float &fa, float &fb)
{
	float fc;
	fc = fa;
	fa = fb;
	fb = fc;
}

template < typename T > void
SwapT (T & ta, T & tb)
{
	T tc;
	tc = ta;
	ta = tb;
	tb = tc;
}

int
main (int argc, char **argv)
{
	int a = 1, b = 2;
	cout << " a " << a << " b " << b << endl;
	SwapInt (a, b);
	cout << " a " << a << " b " << b << endl;

	float c = 1.111, d = 2.222;
	cout << " c " << c << " d " << d << endl;
	SwapFloat (c, d);

	int i = 5;
	int j = 6;
	cout << " i " << i << " j " << j << endl;
	SwapT (i, j);
	cout << " i " << i << " j " << j << endl;

	double f = 5.55, g = 6.66;
	cout << " f " << f << " g " << g << endl;
	SwapT (f, g);
	cout << " f " << f << " g " << g << endl;

	return 0;
}
