/*
 * Template class example
 * by hackervalley@free.fr
 * http://hackervalley.free.fr
 * January 2004
 * this program is licensed under the GPL.
 */

#include <iostream>

using namespace std;

template < typename T > class CVertex
{
	T x, y, z;
      public:
	CVertex (T inx = 0, T iny = 0, T inz = 0)
	{
		x = inx;
		y = iny;
		z = inz;
	}
	void vSetCVertex (T inx, T iny, T inz);
	void vDisplayCVertex ();
};

template < typename T > void CVertex < T >::vSetCVertex (T inx, T iny, T inz)
{
	x = inx;
	y = iny;
	z = inz;
}

template < typename T > void CVertex < T >::vDisplayCVertex ()
{
	cout << "x = " << x << " y = " << y << " z = " << z << endl;
}

int
main (int argc, char **argv)
{
	CVertex < int >ivertexa;

	ivertexa.vDisplayCVertex ();
	ivertexa.vSetCVertex (1, 2, 3);
	ivertexa.vDisplayCVertex ();

	CVertex < float >ivertexb;

	ivertexb.vDisplayCVertex ();
	ivertexb.vSetCVertex (1.111, 2.222, 3.333);
	ivertexb.vDisplayCVertex ();

	return 0;
}
